---
title: "批量查询任务"

doc_type: static
doc_category: static
doc_version: v20270301
source_url:
  html: 'https://developer.shopline.com/zh-hans-cn/docs/apps/api-instructions-for-use/bulk-operations/bulk-query-task'
  md: 'https://developer.shopline.com/zh-hans-cn/docs/apps/api-instructions-for-use/bulk-operations/bulk-query-task.md'
---
# 批量查询任务

你可以调用 [创建一个批量查询任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/create-a-bulk-query-task.md) 接口向 SHOPLINE 提交复杂的数据查询请求。由于该查询任务为异步任务，结果不会立即返回。任务执行时间取决于查询的复杂度。任务执行完毕后，系统会生成一份包含查询结果的 [JSONL](https://jsonlines.org/) 格式的临时文件，文件有效期为 12 小时。

查询任务提交后，你可以调用 [查询一个有效批量任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/get-a-valid-bulk-task.md) 接口获取该任务的执行状态和结果文件 URL。通过该 URL 下载文件即可获取查询结果数据。

------

## 使用限制

批量查询操作有如下使用限制：

- **并发限制**：批量查询任务按店铺维度串行执行。同一时刻，每个店铺只能拥有一个正在执行的批量查询任务。若当前已有任务执行中，SHOPLINE 将拒收该店铺的其他批量查询任务（无论是否来自同一应用），直至当前任务完成。
- **权限要求**：应用必须拥有 `write_bulkoperation` 和 `read_bulkoperation` 权限点。关于如何申请权限，参考 [应用授权](https://developer.shopline.com/zh-hans-cn/docs/apps/api-instructions-for-use/app-authorization.md)。
- **数据量限制**：单次最多可查询 10,000 条数据记录。
- **API 版本要求**：须使用 `v20220901` 或更高版本的 API 版本。

> **注意**
>
> 若你的应用在批量查询任务完成后未及时调用 [查询一个有效批量任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/get-a-valid-bulk-task.md) 接口获取查询结果，且在此期间该店铺的其他应用提交了新的批量查询任务，后续你的应用调用接口获取结果数据时将得到该新任务的执行结果。因此建议你在批量查询任务结束后及时调用 [查询一个有效批量任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/get-a-valid-bulk-task.md) 拉取结果数据。

------

## 操作流程

按如下步骤进行批量查询操作：

1. **提交任务**：调用 [创建一个批量查询任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/create-a-bulk-query-task.md) 接口提交任务。
2. **轮询状态**：调用 [查询一个有效批量任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/get-a-valid-bulk-task.md) 接口获取查询任务的状态和结果文件 URL。
3. **获取结果**：当任务执行完毕后，通过结果文件 URL 下载并解析 JSONL 文件，以获取查询结果并进行相应数据处理工作。

------

## 场景示例：导出全部商品数据

如果需要导出 SHOPLINE 店铺的全部商品数据用于离线分析，可采用如下步骤：

### 前提条件

确保你的应用已拥有 `read_products`、`read_bulkoperation` 和 `write_bulkoperation` 权限点。

### 步骤一：提交查询任务

调用 [创建一个批量查询任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/create-a-bulk-query-task.md) 接口，获取当前店铺的全部商品。

请求示例：

```plain
curl --location --request POST 'https://{handle}.myshopline.com/admin/openapi/v20260901/bulk_operation_run_query.json' \

--header 'Authorization: Bearer {accessToken}' \

--header 'Content-Type: application/json; charset=utf-8' \

--data-raw '{
"method": "GET",
"query_path": "https://{handle}.myshopline.com/admin/openapi/v20260901/products/products.json"
}'
```

> **注意**
>
> - `query_path` 必须包含该接口的完整路径，路径中可以包含对应接口文档中定义的条件参数。
> - 当返回的 HTTP 状态码为 `200` 时，表示任务提交成功。

### 步骤二：查询任务状态和结果

调用 [查询一个有效批量任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/get-a-valid-bulk-task.md) 接口，获取上一步提交的查询任务状态和结果。

> **提示**
>
> 你也可以订阅 [批量任务状态更新](https://developer.shopline.com/zh-hans-cn/docs/webhook/batch-operation/bulk-task-status-updated.md) Webhook 通知。当有批量查询任务的状态更新时，系统会触发此 Webhook 通知，你可以根据通知信息中的以下字段了解相应的任务信息和获取结果文件 URL：
> 
> - `status`：该任务的状态。
> - `type`：该任务的类型。
> - `url`：该任务的结果文件 URL。

请求示例：

```plain
curl --location -g --request GET 'https://{handle}.myshopline.com/admin/openapi/v20260901/current_bulk_operation.json?type=QUERY' \

--header 'Authorization: Bearer {accessToken}' \

--header 'Content-Type: application/json; charset=utf-8' \

--data-raw ''
```

> **注意**
>
> 请求路径中需添加 `type=QUERY`，表示请求的是批量查询任务。

返回示例：

```plain
{
  "partialDataUrl": null,
  "createdAt": "2023-05-24T14:53:45+08:00",
  "expiredAt": null,
  "reason": null,
  "completedAt": null,
  "errorCode": null,
  "id": "gid://shopline/BulkOperation/XX",
  "type": "QUERY",
  "completedCount": 0,
  "storeId": "xx",
  "url": null,
  "status": "CREATED"
}
```

### 步骤三：下载并解析 JSONL 文件

若调用 [查询一个有效批量任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/get-a-valid-bulk-task.md) 接口或 [批量任务状态更新](https://developer.shopline.com/zh-hans-cn/docs/webhook/batch-operation/bulk-task-status-updated.md) Webhook 通知返回的 `status` 字段为 `COMPLETED`，代表批量查询任务已完成。此时，可通过返回的 `url` 字段下载 JSONL 文件。该文件中每一行数据都是有效的 JSON 值，例如：

```plain
{"products":[{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"},"body_html":"<p>Women's Coat</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"}],"created_at":"2021-01-15T16:01:01+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":44,"image":null,"required_shipping":true,"compare_at_price":"8888.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703820546801691661","price":"8888.00","product_id":"16047038205454092052571954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038205456944179971954","option2":null,"position":1,"sku":"shopline-pre-000002","barcode":"shopline-pre-000002"}],"title":"Women's Coat","tags":"Winter Wear","published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-18T16:47:23+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038205454092052571954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"},"body_html":"<p>Knitted Cardigan</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"}],"created_at":"2021-01-15T16:05:30+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":12989,"image":null,"required_shipping":true,"compare_at_price":"12.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703825058429955139","price":"10.00","product_id":"16047038250581279877401954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038250582286510351954","option2":null,"position":1,"sku":"shopline-pre-000003","barcode":"shopline-pre-000003"}],"title":"Knitted Cardigan","tags":null,"published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-09T10:54:57+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038250581279877401954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},"body_html":"\n No transaction fees. No design or technical skills required. Integrated with multiple payment and logistic options. With over 120,000 merchants online. Everything you need for your e-commerce store.\n","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804227855397"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804378850369"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804513068056"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804664063031"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804798280754"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805033161772"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805251265575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805402260546"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805553255504"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805687473245"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805855245357"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806006240293"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806140458063"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806291452929"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806442447877"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806610220088"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806777992252"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806928987159"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807063204924"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807214199831"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807348417575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807482635364"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807633630248"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807767848028"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807935620136"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808086615081"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808220832823"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808355050529"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808506045509"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808640263253"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808740926532"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808891921424"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809042916445"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809328129050"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809512678433"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809663673411"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809814668294"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809982440540"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524810133435400"}],"created_at":"2021-01-18T10:09:38+08:00","template_path":null,"handle":"TestGoods23","variants":[{"inventory_quantity":998,"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/64a15e63737447dda83ca9668a64ddbd.jpeg?w=2000&h=682","alt":null,"id":"5759524810317984865"},"required_shipping":true,"compare_at_price":"23.00","taxable":true,"option5":null,"weight":"123.99","title":"green · L1","inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4707815481808813083","price":"23.00","product_id":"16047078154805505433761954","option3":null,"option4":null,"inventory_tracker":true,"option1":"green","id":"18047078154806512066751954","option2":"L1","position":1,"sku":"green_l1","barcode":null}],"title":"TestGoods23","tags":"123,abc,shopline","published_scope":"web","product_type":"NORMAL","updated_at":"2023-01-13T23:08:59+08:00","vendor":null,"subtitle":null,"options":[{"product_id":"16047078154805505433761954","values":["green"],"values_images":{},"name":"color","id":"16147078154806512066781954"},{"product_id":"16047078154805505433761954","values":["L1"],"values_images":{},"name":"custom_1","id":"16147078154806512066811954"}],"spu":null,"id":"16047078154805505433761954","published_at":"2021-01-18T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"}]}
{"products":[{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"},"body_html":"<p>Women's Coat</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"}],"created_at":"2021-01-15T16:01:01+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":44,"image":null,"required_shipping":true,"compare_at_price":"8888.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703820546801691661","price":"8888.00","product_id":"16047038205454092052571954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038205456944179971954","option2":null,"position":1,"sku":"shopline-pre-000002","barcode":"shopline-pre-000002"}],"title":"Women's Coat","tags":"Winter Wear","published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-18T16:47:23+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038205454092052571954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"},"body_html":"<p>Knitted Cardigan</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"}],"created_at":"2021-01-15T16:05:30+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":12989,"image":null,"required_shipping":true,"compare_at_price":"12.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703825058429955139","price":"10.00","product_id":"16047038250581279877401954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038250582286510351954","option2":null,"position":1,"sku":"shopline-pre-000003","barcode":"shopline-pre-000003"}],"title":"Knitted Cardigan","tags":null,"published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-09T10:54:57+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038250581279877401954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},"body_html":"\n No transaction fees. No design or technical skills required. Integrated with multiple payment and logistic options. With over 120,000 merchants online. Everything you need for your e-commerce store.\n","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804227855397"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804378850369"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804513068056"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804664063031"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804798280754"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805033161772"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805251265575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805402260546"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805553255504"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805687473245"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805855245357"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806006240293"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806140458063"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806291452929"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806442447877"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806610220088"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806777992252"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806928987159"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807063204924"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807214199831"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807348417575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807482635364"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807633630248"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807767848028"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807935620136"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808086615081"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808220832823"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808355050529"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808506045509"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808640263253"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808740926532"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808891921424"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809042916445"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809328129050"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809512678433"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809663673411"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809814668294"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809982440540"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524810133435400"}],"created_at":"2021-01-18T10:09:38+08:00","template_path":null,"handle":"TestGoods23","variants":[{"inventory_quantity":998,"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/64a15e63737447dda83ca9668a64ddbd.jpeg?w=2000&h=682","alt":null,"id":"5759524810317984865"},"required_shipping":true,"compare_at_price":"23.00","taxable":true,"option5":null,"weight":"123.99","title":"green · L1","inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4707815481808813083","price":"23.00","product_id":"16047078154805505433761954","option3":null,"option4":null,"inventory_tracker":true,"option1":"green","id":"18047078154806512066751954","option2":"L1","position":1,"sku":"green_l1","barcode":null}],"title":"TestGoods23","tags":"123,abc,shopline","published_scope":"web","product_type":"NORMAL","updated_at":"2023-01-13T23:08:59+08:00","vendor":null,"subtitle":null,"options":[{"product_id":"16047078154805505433761954","values":["green"],"values_images":{},"name":"color","id":"16147078154806512066781954"},{"product_id":"16047078154805505433761954","values":["L1"],"values_images":{},"name":"custom_1","id":"16147078154806512066811954"}],"spu":null,"id":"16047078154805505433761954","published_at":"2021-01-18T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"}]}
{"products":[{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"},"body_html":"<p>Women's Coat</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524798825649163"}],"created_at":"2021-01-15T16:01:01+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":44,"image":null,"required_shipping":true,"compare_at_price":"8888.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703820546801691661","price":"8888.00","product_id":"16047038205454092052571954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038205456944179971954","option2":null,"position":1,"sku":"shopline-pre-000002","barcode":"shopline-pre-000002"}],"title":"Women's Coat","tags":"Winter Wear","published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-18T16:47:23+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038205454092052571954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"},"body_html":"<p>Knitted Cardigan</p>","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524799529665633"}],"created_at":"2021-01-15T16:05:30+08:00","template_path":null,"handle":null,"variants":[{"inventory_quantity":12989,"image":null,"required_shipping":true,"compare_at_price":"12.00","taxable":true,"option5":null,"weight":"0.00","title":null,"inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4703825058429955139","price":"10.00","product_id":"16047038250581279877401954","option3":null,"option4":null,"inventory_tracker":true,"option1":null,"id":"18047038250582286510351954","option2":null,"position":1,"sku":"shopline-pre-000003","barcode":"shopline-pre-000003"}],"title":"Knitted Cardigan","tags":null,"published_scope":"web","product_type":"NORMAL","updated_at":"2022-10-09T10:54:57+08:00","vendor":null,"subtitle":null,"options":[],"spu":null,"id":"16047038250581279877401954","published_at":"2021-01-15T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"},{"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},"body_html":"\n No transaction fees. No design or technical skills required. Integrated with multiple payment and logistic options. With over 120,000 merchants online. Everything you need for your e-commerce store.\n","images":[{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/7e56419e366a44f5ac35d45c87b1e53c.jpeg?w=351&h=319","alt":null,"id":"5759524804076860494"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804227855397"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804378850369"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804513068056"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804664063031"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524804798280754"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805033161772"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805251265575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805402260546"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805553255504"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805687473245"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524805855245357"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806006240293"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806140458063"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806291452929"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806442447877"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806610220088"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806777992252"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524806928987159"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807063204924"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807214199831"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807348417575"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807482635364"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807633630248"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807767848028"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524807935620136"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808086615081"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808220832823"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808355050529"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808506045509"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808640263253"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808740926532"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524808891921424"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809042916445"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809328129050"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809512678433"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809663673411"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809814668294"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524809982440540"},{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/49586ae18ad84ad5bd947cb8e0fff2c4.jpeg?w=500&h=686","alt":null,"id":"5759524810133435400"}],"created_at":"2021-01-18T10:09:38+08:00","template_path":null,"handle":"TestGoods23","variants":[{"inventory_quantity":998,"image":{"src":"https://img.myshopline.com/image/store/2000006509/1610418722314/64a15e63737447dda83ca9668a64ddbd.jpeg?w=2000&h=682","alt":null,"id":"5759524810317984865"},"required_shipping":true,"compare_at_price":"23.00","taxable":true,"option5":null,"weight":"123.99","title":"green · L1","inventory_policy":"deny","weight_unit":"kg","inventory_item_id":"4707815481808813083","price":"23.00","product_id":"16047078154805505433761954","option3":null,"option4":null,"inventory_tracker":true,"option1":"green","id":"18047078154806512066751954","option2":"L1","position":1,"sku":"green_l1","barcode":null}],"title":"TestGoods23","tags":"123,abc,shopline","published_scope":"web","product_type":"NORMAL","updated_at":"2023-01-13T23:08:59+08:00","vendor":null,"subtitle":null,"options":[{"product_id":"16047078154805505433761954","values":["green"],"values_images":{},"name":"color","id":"16147078154806512066781954"},{"product_id":"16047078154805505433761954","values":["L1"],"values_images":{},"name":"custom_1","id":"16147078154806512066811954"}],"spu":null,"id":"16047078154805505433761954","published_at":"2021-01-18T00:00:00+08:00","product_behavior":"","product_category":null,"status":"active"}]}
```

你可以用任意编程语言解析该 JSONL 文件，以便后续处理数据。

### 步骤四：执行断点续查

当批量查询任务因某种原因被中断时，将无法查询到符合条件的全部数据，生成的 JSONL 文件只包含任务中断时已执行的查询对应的部分结果数据。你可以通过 [查询一个有效批量任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/get-a-valid-bulk-task.md) 接口返回的 `partialDataUrl` 字段获取该部分结果数据的 JSONL 文件 URL 并下载文件。

> **注意**
>
> `url` 和 `partialDataUrl` 字段对应的 JSONL 文件有效期均为 12 小时，到期后将被清除。

批量查询任务被中断后，你可以通过返回的部分结果文件继续提交查询任务，步骤如下：

1. 解析部分结果文件的最后一行数据。
2. 获取该行数据的 `since_id` 字段值，例如：`5759524798825649163`。
3. 在原批量查询任务请求参数 `query_path` 的尾部拼接如下内容：`since_id=5759524798825649163`。
4. 调用 [创建一个批量查询任务](https://developer.shopline.com/zh-hans-cn/docs/admin-rest-api/bulk-operations/create-a-bulk-query-task.md) 接口再次提交请求。

------

## 故障排查

SHOPLINE 可能会终止批量查询任务的执行，常见原因如下：

- **权限不足**：你的应用没有查询目标资源的权限，需先申请相应权限。
- **内部异常**：由于非预期原因导致系统无法处理你的应用提交的查询请求。可尝试重新提交请求。
- **Access token 过期**：在执行任务期间，你的应用的 access token 过期了。需使用有效 access token 重新提交请求。